-- =============================================
-- Author:		FID.Ridwan
-- Create date: 28.09.2020
-- Description:	
-- =============================================
CREATE FUNCTION [dbo].[FN_JPO_MATERIALNO_CONV] (@mat_no VARCHAR(50))
RETURNS VARCHAR(500)
AS
BEGIN
	DECLARE @RESULT VARCHAR(500)
		,@RV_MAT_NO_1 VARCHAR(100) = ''
		,@RV_MAT_NO_2 VARCHAR(100) = ''
		,@RV_MAT_NO_3 VARCHAR(100) = ''
		,@RV_PART_COLOR_SUFFIX VARCHAR(10) = ''
		,@RV_COMPONENT_PART_FLAG VARCHAR(1) = ''
		,@MSG VARCHAR(100) = ''
		,@FLAG CHAR(1) = '0';

	--* Get Material No. From TB_M_MATERIAL_MASTER_MAPPING *--
	SELECT @RV_MAT_NO_3 = M.ICS_MAT_NO
	FROM TB_M_MATERIAL_MASTER_MAPPING M
	WHERE M.ORI_MAT_NO = @mat_no;

	IF ISNULL(@RV_MAT_NO_3, '') <> ''
	BEGIN
		SET @RV_MAT_NO_1 = @RV_MAT_NO_3;
		SET @RV_PART_COLOR_SUFFIX = 'X';
		SET @RV_COMPONENT_PART_FLAG = 'N';
		SET @MSG = '';
		SET @FLAG = '0';
	END
	ELSE
		--* If no mapping found on TB_M_MATERIAL_MASTER_MAPPING, Call Function FN_MATERIALNO_CONV_FIRST *--
	BEGIN
		/* validate parameter input */
		IF (
				ISNULL(@mat_no, '') = ''
				OR LEN(@mat_no) > 30
				)
		BEGIN
			SET @MSG = 'ORIGINAL MATERIAL NO must be less than or equal to 30';
			SET @FLAG = '2';
		END
		ELSE
		BEGIN
			DECLARE @L_V_SM_PART_COLOR_SFX VARCHAR(100);
			DECLARE @L_V_SM_ORI_COMP_MAT VARCHAR(100);
			DECLARE @L_V_SM_COMP_MAT VARCHAR(100);
			DECLARE @LC_PART_FLAG VARCHAR(100);
			DECLARE @L_N_STATUS VARCHAR(100);

			SELECT @L_V_SM_PART_COLOR_SFX = SYSTEM_VALUE
			FROM TB_M_SYSTEM
			WHERE FUNCTION_ID = 'JPO_TO_ICS'
				AND SYSTEM_CD = 'PART_COLOR_SFX'

			SELECT @L_V_SM_ORI_COMP_MAT = SYSTEM_VALUE
			FROM TB_M_SYSTEM
			WHERE FUNCTION_ID = 'JPO_TO_ICS'
				AND SYSTEM_CD = 'ORI_COMP_MAT_LENGTH'

			SELECT @L_V_SM_COMP_MAT = SYSTEM_VALUE
			FROM TB_M_SYSTEM
			WHERE FUNCTION_ID = 'JPO_TO_ICS'
				AND SYSTEM_CD = 'COMP_MAT_LENGTH'

			/* check the length of original material number */
			IF LEN(@mat_no) <> CAST(@L_V_SM_ORI_COMP_MAT AS INT)
			BEGIN
				SELECT @LC_PART_FLAG = T.PART_FLAG
				FROM TB_M_MATERIAL T
				WHERE T.MAT_NO = @mat_no;

				SET @RV_MAT_NO_1 = @mat_no;
				SET @RV_COMPONENT_PART_FLAG = @LC_PART_FLAG;
				SET @RV_PART_COLOR_SUFFIX = @L_V_SM_PART_COLOR_SFX;
				SET @MSG = '';
				SET @FLAG = '0';
			END
			ELSE
				IF LEN(@mat_no) = CAST(@L_V_SM_ORI_COMP_MAT AS INT)
				BEGIN
					SELECT @LC_PART_FLAG = T.PART_FLAG
					FROM TB_M_MATERIAL T
					WHERE T.MAT_NO = SUBSTRING(@mat_no, 1, CAST(@L_V_SM_COMP_MAT AS INT));

					IF ISNULL(@LC_PART_FLAG, 'N') = 'Y'
					BEGIN
						SET @RV_MAT_NO_1 = SUBSTRING(@mat_no, 1, CAST(@L_V_SM_COMP_MAT AS INT));
						SET @RV_PART_COLOR_SUFFIX = SUBSTRING(@mat_no, 11, 2);
						SET @RV_COMPONENT_PART_FLAG = 'Y';
						SET @MSG = '';
						SET @FLAG = '0';
					END
					ELSE
					BEGIN
						SELECT @L_N_STATUS = 1
						FROM TB_M_MATERIAL T
						WHERE T.MAT_NO = @mat_no;

						SET @RV_MAT_NO_1 = @mat_no;
						SET @RV_PART_COLOR_SUFFIX = @L_V_SM_PART_COLOR_SFX;
						SET @RV_COMPONENT_PART_FLAG = 'N';
						SET @MSG = '';
						SET @FLAG = '0';
					END
				END
		END
	END

	IF (ISNULL(@RV_MAT_NO_1, '') = '' OR ISNULL(@RV_COMPONENT_PART_FLAG, '') = '') AND ISNULL(@MSG, '') = ''
	BEGIN
		SET @RV_MAT_NO_1 = '';
		SET @RV_PART_COLOR_SUFFIX = '';
		SET @RV_COMPONENT_PART_FLAG = '';
		SET @MSG = 'Material Number is not Found!';
		SET @FLAG = '1';
	END

	SET @RESULT = @RV_MAT_NO_1 + '|' + @RV_PART_COLOR_SUFFIX + '|' + @RV_COMPONENT_PART_FLAG + '|' + @MSG + '|' + @FLAG;

	RETURN @RESULT
END
